/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015      by 3rd Designing Center
 *              Imageing System Development Division RICOH COMPANY, LTD.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_inithook.c 698 2015-08-01 15:00:08Z roi $
 */

#include <sil.h>
#include "stm32f4xx.h"

/*
 *  ץstm32f4-discoveryѡ
 */

#define HSE_STARTUP_TIMEOUT 0x0500		/* HSEѥॢ */

/*
 *  PLL
 */
#define PLL_M      8
#define PLL_N      336
#define PLL_P      2
#define PLL_Q      7

#define PLLI2S_N   192
#define PLLI2S_R   5

#define RCC_CFGR_SW       (RCC_CFGR_SW_0 | RCC_CFGR_SW_1)
#define RCC_CFGR_SWS      (RCC_CFGR_SWS_0 | RCC_CFGR_SWS_1)

/*
 *  ٥ΥåȰ¸ν
 *
 *  ȥåץ⥸塼ǡν˸ƤӽФ롥
 */
void hardware_init_hook(void)
{
	unsigned int StartUpCounter = 0, HSEStatus = 0;

	/*
	 *  RCCΥꥻåȤȥե졼
	 */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) | RCC_CR_HSION);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), 0x00000000);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & ~(RCC_CR_PLLON | RCC_CR_CSSON | RCC_CR_HSEON));
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR), RCC_CFGR_MCO2PRE_2 | RCC_CFGR_MCO1PRE_2
					 | RCC_CFGR_PPRE2_0 | RCC_CFGR_PPRE1_DIV2 | RCC_CFGR_HPRE_0);

	/* Reset HSEBYP bit */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & ~RCC_CR_HSEBYP);

	/*
	 *  ߶ػ
	 */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CIR), 0x00000000);

	/*
	 *  HSEͭ
	 */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) | RCC_CR_HSEON);

	/*
	 *  HSEǥԤ
	 */
	do{
		HSEStatus = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSERDY;
		StartUpCounter++;
	}while((HSEStatus == 0) && (StartUpCounter != HSE_STARTUP_TIMEOUT));

	if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSERDY) != 0){
		/* Enable high performance mode, System frequency up to 168 MHz */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1ENR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1ENR)) | RCC_APB1ENR_PWREN);

		sil_wrw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR), sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR)) | PWR_CR_PMODE);

		/*
		 *  HCLKΥե졼
		 */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) | RCC_CFGR_HPRE_DIV1);

		/*
		 *  PCLK2Υե졼
		 */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) | RCC_CFGR_PPRE2_DIV2);

		/*
		 *  PCLK1Υե졼
	 	*/
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) | RCC_CFGR_PPRE1_DIV4);

		/*
		 *  PLL
		 */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR), PLL_M | (PLL_N << 6) | (((PLL_P >> 1) -1) << 16) |
                   (RCC_PLLCFGR_PLLSRC_HSE) | (PLL_Q << 24));

 		/*
		 *  PLLͭ
		 */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) | RCC_CR_PLLON);

		/*
		 *  PLLǥԤ
		 */
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLRDY) == 0)
		{
		}

		/*
		 *  FLASHץեåŬ
		 */
		sil_wrw_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR), FLASH_ACR_ICEN |FLASH_ACR_DCEN |FLASH_ACR_LATENCY_5WS);

		/*
		 *  PLL򥷥ƥ९åȤ
		 */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & ~RCC_CFGR_SW) | RCC_CFGR_SW_PLL);

		/*
		 *  괰λޤԤ
		 */
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_SWS) != RCC_CFGR_SWS_PLL)
		{
		}
	}
	else{
		/*
		 *  HSE顼
		 */
	}

	/*
	 *  I2SΥåȤPLLI2Så
	 */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & ~RCC_CFGR_I2SSRC);

	/*
	 *  PLLI2S
	 */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLI2SCFGR), (PLLI2S_N << 6) | (PLLI2S_R << 28));

	/*
	 *  PLLI2Sͭ
	 */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) | RCC_CR_PLLI2SON);

	/*
	 *  PLLI2SΥǥԤ
	 */
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLI2SRDY) == 0)
	{
	}
}

